format PE64 GUI 5.0 
entry start 

include 'win64a.inc' 

IDR_MENU = 10 
IDR_DIALOG = 11 

IDM_EXIT = 100 
IDM_ABOUT = 101 

IDLG_BUTTON = 120 
IDLG_E = 121
IDLG_R = 122

section '.bss' readable writeable 
hWnd dq 0 
hMenu dq        0 
hInstance dq 0
section '.data' data readable writeable 

;TitleStr TCHAR 'Win64 program',0
;ClassStr TCHAR 'WIN64DEMO',0
hexbuf db "0123456789ABCDEF",0
errm: db "Wrong hex number",0
errm2: db "Number too big",0
;msg MSG

section '.text' code readable executable 

start: 
sub     rsp,8 

invoke  GetModuleHandle,0 

mov     [hInstance],rax

invoke  DialogBoxParam,[hInstance],IDR_DIALOG,0,DialogProc,0

invoke  ExitProcess,0

proc DialogProc uses rbx rsi rdi, hwnd,wmsg,wparam,lparam 
local ps:PAINTSTRUCT,rc:RECT,hDC:QWORD 
;RCX RDX R8 R9
;The registers RAX, RCX, RDX, R8, R9, R10, R11 are considered volatile (caller-saved)
;The registers RBX, RBP, RDI, RSI, RSP, R12, R13, R14, and R15 are considered nonvolatile (callee-saved)
;params in rcx, rdx, r8, r9, [rsp+8*4], [rsp+8*5], [rsp+8*6], ... [rsp+...]
;XMM0, XMM1, XMM2, XMM3 for floating-point arguments
mov     [hwnd],rcx 

cmp     edx,WM_INITDIALOG
je      DLG_INIT

;cmp     edx,WM_PAINT
;je      DLG_PROC_PAINT
cmp     edx,WM_CLOSE 
je      DLG_PROC_CLOSE 
cmp     edx,WM_COMMAND 
je      DLG_PROC_COMMAND
jmp     DLG_PROC_FINISH
DLG_INIT:
invoke  LoadIcon,[hInstance],2
invoke SendMessage,[hwnd],WM_SETICON,ICON_SMALL,rax
jmp     DLG_PROC_FINISH

;DLG_PROC_PAINT:
;lea     rdx,[ps]
;invoke  BeginPaint,[hwnd],rdx
;mov     [hDC],rax
;invoke  GetClientRect,[hwnd],addr rc
;invoke  DrawText,[hDC],TitleStr,-1,addr rc,DT_SINGLELINE + DT_CENTER + DT_VCENTER
;invoke  EndPaint,[hwnd],addr ps
;jmp     DLG_PROC_FINISH

DLG_PROC_COMMAND:
        cmp r8,IDCANCEL
        je DLG_PROC_CLOSE
   cmp r8,IDLG_BUTTON;120 button pressed
   je DLG_PROC_CLOSE
 ;check if Edit wParam=EN_UPDATE.wID=control ID ,lParam=wgnd of control
  cmp r8,IDLG_E+(EN_UPDATE shl 16);+$4000000;EN_UPDATE
  jne DLG_PROC_FINISH
   jmp textproc
   jmp DLG_PROC_FINISH
DLG_PROC_CLOSE: 
invoke  EndDialog,rcx,0 ; hDlg Result
mov     rax,1 
ret
DLG_PROC_FINISH:
   xor rax,rax
ret
textproc:
;push rbx
mov rbx,rcx
invoke  SendDlgItemMessage,rbx,IDLG_E,WM_GETTEXTLENGTH,0,0
or rax,rax
je extp
cmp rax,8
;jg extp
jle dohex
mov esi,errm2
jmp pr2
;-----------------------------------------------
dohex:
mov rsi,hexbuf
invoke  SendDlgItemMessage,rbx,IDLG_E,WM_GETTEXT,14,rsi
;convert ascii to hex
xor rdi,rdi
conh:
movzx rax,byte[ds:rsi]
inc rsi
cmp al,"0"
jl err1
cmp al,"9"
jg islet1
sub al,"0"
jmp put
err1:;;;;;;;;;ERROR converting
mov esi,errm
jmp pr2
islet1:
cmp al,"A"
jl err1
cmp al,"F"
jg islet2
sub al,"A"-10
jmp put
islet2:
cmp al,"a"
jl err1
cmp al,"f"
jg err1
sub al,"a"-10
put:
    shl rdi,4
    add rdi,rax
    cmp byte [ds:rsi],0
    jne conh
;convert hex to decimal
mov rsi,hexbuf+14
    mov byte [ds:rsi],0
;        push rsi
        mov rcx,10
 lp:
        mov rax,rdi
        xor rdx,rdx
        div rcx
        mov rdi,rax
        add rdx,$30
        dec rsi
        mov byte [ds:rsi],dl
 ;       dec rsi
        or rdi,rdi
        jne lp
;        inc rsi
;        mov byte [ds:rsi],0
;
;mirror text
;        pop rdi
;        mov rcx,rsi
;        sub rcx,rdi
;        shr rcx,1
;         dec rsi

;        or rcx,rcx
;        je print
;mirror:
;        mov ah,byte [ds:rsi]
;        mov al,byte [ds:rdi]
;        mov byte [ds:rsi],al
;        mov byte [ds:rdi],ah
;        inc rdi
;        dec rsi
;        loop mirror
;output
;print:
;        mov rsi,hexbuf
pr2:
invoke  SendDlgItemMessage,rbx,IDLG_R,WM_SETTEXT,0,rsi

;-----------------------------------------------
extp:
jmp DLG_PROC_FINISH
endp 

section '.idata' import data readable writeable 

library kernel32,'KERNEL32.DLL',\ 
user32,'USER32.DLL' 

include 'api\kernel32.inc' 
include 'api\user32.inc' 

section '.rsrc' resource data readable 


directory RT_DIALOG,dialogs,\
RT_ICON,icons,\
RT_GROUP_ICON,group_icons




resource dialogs,\ 
IDR_DIALOG,LANG_ENGLISH+SUBLANG_DEFAULT,Dialog64 


;https://board.flatassembler.net/topic.php?t=20961
dialog Dialog64,'64bit hex2dec',0,0,250,50,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME+WS_OVERLAPPED+DS_CENTER
dialogitem 'EDIT','',IDLG_E,5,5,185,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP+ES_CENTER
dialogitem 'EDIT','',IDLG_R,5,25,185,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP+ES_CENTER

;dialogitem 'BUTTON','close',IDLG_BUTTON,200,78,40,14,WS_VISIBLE
enddialog    

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           2,LANG_NEUTRAL,main_icon
icon main_icon,icon_data,'APPLICATION.ico'